diff --git a/src/postgres/src/backend/catalog/index.c b/src/postgres/src/backend/catalog/index.c
index d6153d71e70c..246ec311ede6 100644
--- a/src/postgres/src/backend/catalog/index.c
+++ b/src/postgres/src/backend/catalog/index.c
@@ -80,8 +80,10 @@
 #include "utils/tqual.h"
 
 /*  YB includes. */
+#include "commands/progress.h"
 #include "commands/ybccmds.h"
 #include "pg_yb_utils.h"
+#include "pgstat.h"
 
 /* Potentially set by pg_upgrade_support functions */
 Oid			binary_upgrade_next_index_pg_class_oid = InvalidOid;
@@ -1312,6 +1314,11 @@ index_create(Relation heapRelation,
 	}
 	else
 	{
+		if (IsYugaByteEnabled() && !concurrent && !invalid &&
+			yb_test_block_index_phase[0] != '\0')
+			YbTestGucBlockWhileStrEqual(&yb_test_block_index_phase,
+										"backfill",
+										"non-concurrent index backfill");
 		index_build(heapRelation, indexRelation, indexInfo, isprimary, false,
 					true);
 	}
@@ -1322,6 +1329,13 @@ index_create(Relation heapRelation,
 	 */
 	index_close(indexRelation, NoLock);
 
+	if (IsYugaByteEnabled() && !concurrent && !invalid &&
+		yb_test_block_index_phase[0] != '\0')
+		YbTestGucBlockWhileStrEqual(&yb_test_block_index_phase,
+									"postbackfill",
+									"operations after a non-concurrent "
+									"index backfill");
+
 	return indexRelationId;
 }
 
@@ -2415,6 +2429,10 @@ index_build(Relation heapRelation,
 						   save_sec_context | SECURITY_RESTRICTED_OPERATION);
 	save_nestlevel = NewGUCNestLevel();
 
+	if (IsYugaByteEnabled())
+		pgstat_progress_update_param(PROGRESS_CREATEIDX_PHASE,
+									 YB_PROGRESS_CREATEIDX_BACKFILLING);
+
 	/*
 	 * Call the access method's build procedure
 	 */
@@ -2732,6 +2750,7 @@ IndexBuildHeapRangeScanInternal(Relation heapRelation,
 	BlockNumber root_blkno = InvalidBlockNumber;
 	OffsetNumber root_offsets[MaxHeapTuplesPerPage];
 	MemoryContext oldcontext = GetCurrentMemoryContext();
+	int			yb_tuples_done = 0;
 
 	/*
 	 * sanity checks
@@ -3159,7 +3178,12 @@ IndexBuildHeapRangeScanInternal(Relation heapRelation,
 		if (predicate != NULL)
 		{
 			if (!ExecQual(predicate, econtext))
+			{
+				if (IsYBRelation(indexRelation) && !indexInfo->ii_Concurrent)
+					pgstat_progress_update_param(PROGRESS_CREATEIDX_TUPLES_DONE,
+												 ++yb_tuples_done);
 				continue;
+			}
 		}
 
 		/*
@@ -3215,7 +3239,12 @@ IndexBuildHeapRangeScanInternal(Relation heapRelation,
 		}
 
 		if (IsYBRelation(indexRelation))
+		{
 			MemoryContextReset(econtext->ecxt_per_tuple_memory);
+			if (!indexInfo->ii_Concurrent)
+				pgstat_progress_update_param(PROGRESS_CREATEIDX_TUPLES_DONE,
+											 ++yb_tuples_done);
+		}
 	}
 
 	if (IsYBRelation(indexRelation))
diff --git a/src/postgres/src/backend/catalog/yb_system_views.sql b/src/postgres/src/backend/catalog/yb_system_views.sql
index c1ac00e5ffed..376053fa6105 100644
--- a/src/postgres/src/backend/catalog/yb_system_views.sql
+++ b/src/postgres/src/backend/catalog/yb_system_views.sql
@@ -926,6 +926,31 @@ CREATE VIEW pg_stat_progress_copy AS
     FROM pg_stat_get_progress_info('COPY') AS S
         LEFT JOIN pg_database D ON S.datid = D.oid;
 
+CREATE VIEW pg_stat_progress_create_index AS
+	SELECT
+		S.pid AS pid, S.datid AS datid, D.datname AS datname,
+		S.relid AS relid,
+		CAST(S.param7 AS oid) AS index_relid,
+		CASE S.param1 WHEN 1 THEN 'CREATE INDEX NONCONCURRENTLY'
+					  WHEN 2 THEN 'CREATE INDEX CONCURRENTLY'
+					  WHEN 3 THEN 'REINDEX NONCONCURRENTLY'
+					  WHEN 4 THEN 'REINDEX CONCURRENTLY'
+					  END AS command,
+		CASE S.param10 WHEN 0 THEN 'initializing'
+					   WHEN 1 THEN 'backfilling'
+					   END AS phase,
+		S.param4 AS lockers_total,
+		S.param5 AS lockers_done,
+		S.param6 AS current_locker_pid,
+		S.param16 AS blocks_total,
+		S.param17 AS blocks_done,
+		S.param12 AS tuples_total,
+		S.param13 AS tuples_done,
+		S.param14 AS partitions_total,
+		S.param15 AS partitions_done
+	FROM pg_stat_get_progress_info('CREATE INDEX') AS S
+		LEFT JOIN pg_database D ON S.datid = D.oid;
+
 CREATE VIEW pg_user_mappings AS
     SELECT
         U.oid       AS umid,
diff --git a/src/postgres/src/backend/commands/indexcmds.c b/src/postgres/src/backend/commands/indexcmds.c
index f5b1b0c44d37..5ba47a278147 100644
--- a/src/postgres/src/backend/commands/indexcmds.c
+++ b/src/postgres/src/backend/commands/indexcmds.c
@@ -67,8 +67,10 @@
 
 /* YB includes. */
 #include "catalog/pg_database.h"
+#include "commands/progress.h"
 #include "commands/tablegroup.h"
 #include "pg_yb_utils.h"
+#include "pgstat.h"
 
 /* non-export function prototypes */
 static void CheckPredicate(Expr *predicate);
@@ -379,6 +381,26 @@ DefineIndex(Oid relationId,
 
 	root_save_nestlevel = NewGUCNestLevel();
 
+	/*
+	 * Start progress report.  If we're building a partition, this was already
+	 * done.
+	 */
+	if (!OidIsValid(parentIndexId))
+	{
+		pgstat_progress_start_command(PROGRESS_COMMAND_CREATE_INDEX,
+									  relationId);
+		pgstat_progress_update_param(PROGRESS_CREATEIDX_COMMAND,
+									 stmt->concurrent ?
+									 PROGRESS_CREATEIDX_COMMAND_CREATE_CONCURRENTLY :
+									 PROGRESS_CREATEIDX_COMMAND_CREATE);
+	}
+
+	/*
+	 * No index OID to report yet
+	 */
+	pgstat_progress_update_param(PROGRESS_CREATEIDX_INDEX_OID,
+								 InvalidOid);
+
 	/*
 	 * count key attributes in index
 	 */
@@ -412,6 +434,21 @@ DefineIndex(Oid relationId,
 	 */
 	rel = heap_open(relationId, AccessShareLock);
 
+	if (IsYugaByteEnabled())
+	{
+		const int	cols[] = {
+			PROGRESS_CREATEIDX_PHASE,
+			PROGRESS_CREATEIDX_TUPLES_TOTAL,
+			PROGRESS_CREATEIDX_TUPLES_DONE,
+		};
+		const int64	values[] = {
+			YB_PROGRESS_CREATEIDX_INITIALIZING,
+			rel->rd_rel->reltuples,
+			0
+		};
+		pgstat_progress_update_multi_param(3, cols, values);
+	}
+
 	/*
 	 * Switch to the table owner's userid, so that any index functions are run
 	 * as that user.  Also lock down security-restricted operations.  We
@@ -1130,6 +1167,11 @@ DefineIndex(Oid relationId,
 		SetUserIdAndSecContext(root_save_userid, root_save_sec_context);
 
 		heap_close(rel, NoLock);
+
+		/* If this is the top-level index, we're done */
+		if (!OidIsValid(parentIndexId))
+			pgstat_progress_end_command();
+
 		return address;
 	}
 
@@ -1168,6 +1210,9 @@ DefineIndex(Oid relationId,
 			TupleDesc	parentDesc;
 			Oid		   *opfamOids;
 
+			pgstat_progress_update_param(PROGRESS_CREATEIDX_PARTITIONS_TOTAL,
+										 nparts);
+
 			memcpy(part_oids, partdesc->oids, sizeof(Oid) * nparts);
 
 			parentDesc = CreateTupleDescCopy(RelationGetDescr(rel));
@@ -1340,6 +1385,8 @@ DefineIndex(Oid relationId,
 										   child_save_sec_context);
 				}
 
+				pgstat_progress_update_param(PROGRESS_CREATEIDX_PARTITIONS_DONE,
+											 i + 1);
 				pfree(attmap);
 			}
 
@@ -1376,6 +1423,8 @@ DefineIndex(Oid relationId,
 		 */
 		AtEOXact_GUC(false, root_save_nestlevel);
 		SetUserIdAndSecContext(root_save_userid, root_save_sec_context);
+		if (!OidIsValid(parentIndexId))
+			pgstat_progress_end_command();
 		return address;
 	}
 
@@ -1386,6 +1435,11 @@ DefineIndex(Oid relationId,
 	{
 		/* Close the heap and we're done, in the non-concurrent case */
 		heap_close(rel, NoLock);
+
+		/* If this is the top-level index, we're done. */
+		if (!OidIsValid(parentIndexId))
+			pgstat_progress_end_command();
+
 		return address;
 	}
 
@@ -1430,12 +1484,19 @@ DefineIndex(Oid relationId,
 
 	/* Delay after committing pg_index update. */
 	pg_usleep(yb_index_state_flags_update_delay * 1000);
-	if (IsYugaByteEnabled() && yb_test_block_index_state_change[0] != '\0')
-		YbTestGucBlockWhileStrEqual(&yb_test_block_index_state_change,
+	if (IsYugaByteEnabled() && yb_test_block_index_phase[0] != '\0')
+		YbTestGucBlockWhileStrEqual(&yb_test_block_index_phase,
 									"indisready",
 									"index state change indisready=true");
 
 	StartTransactionCommand();
+
+	/*
+	 * The index is now visible, so we can report the OID.
+	 */
+	pgstat_progress_update_param(PROGRESS_CREATEIDX_INDEX_OID,
+								 indexRelationId);
+
 	YBIncrementDdlNestingLevel();
 
 	/*
@@ -1456,23 +1517,28 @@ DefineIndex(Oid relationId,
 
 	/* Delay after committing pg_index update. */
 	pg_usleep(yb_index_state_flags_update_delay * 1000);
-	if (IsYugaByteEnabled() && yb_test_block_index_state_change[0] != '\0')
-		YbTestGucBlockWhileStrEqual(&yb_test_block_index_state_change,
-									"getsafetime",
-									"index state change to getsafetime");
+	if (IsYugaByteEnabled() && yb_test_block_index_phase[0] != '\0')
+		YbTestGucBlockWhileStrEqual(&yb_test_block_index_phase,
+									"backfill",
+									"concurrent index backfill");
 
 	StartTransactionCommand();
 	YBIncrementDdlNestingLevel();
 
+	if (IsYugaByteEnabled())
+		pgstat_progress_update_param(PROGRESS_CREATEIDX_PHASE,
+									 YB_PROGRESS_CREATEIDX_BACKFILLING);
+
 	/* TODO(jason): handle exclusion constraints, possibly not here. */
 
 	/* Do backfill. */
 	HandleYBStatus(YBCPgBackfillIndex(databaseId, indexRelationId));
 
-	if (IsYugaByteEnabled() && yb_test_block_index_state_change[0] != '\0')
-		YbTestGucBlockWhileStrEqual(&yb_test_block_index_state_change,
-									"indisvalid",
-									"index state change indisvalid=true");
+	if (IsYugaByteEnabled() && yb_test_block_index_phase[0] != '\0')
+		YbTestGucBlockWhileStrEqual(&yb_test_block_index_phase,
+									"postbackfill",
+									"operations after concurrent "
+									"index backfill");
 
 	/*
 	 * Index can now be marked valid -- update its pg_index entry
@@ -1494,6 +1560,8 @@ DefineIndex(Oid relationId,
 	 */
 	UnlockRelationIdForSession(&heaprelid, ShareUpdateExclusiveLock);
 
+	pgstat_progress_end_command();
+
 	return address;
 }
 
diff --git a/src/postgres/src/backend/postmaster/pgstat.c b/src/postgres/src/backend/postmaster/pgstat.c
index 8891f6c2f895..fec384e4610a 100644
--- a/src/postgres/src/backend/postmaster/pgstat.c
+++ b/src/postgres/src/backend/postmaster/pgstat.c
@@ -70,6 +70,7 @@
 #include "utils/tqual.h"
 
 #include "catalog/pg_database.h"
+#include "commands/progress.h"
 #include "pg_yb_utils.h"
 #include "utils/syscache.h"
 
@@ -146,6 +147,12 @@ char	   *pgstat_ybstat_tmpname = NULL;
  */
 PgStat_MsgBgWriter BgWriterStats;
 
+/*
+ * Used in YB to indicate whether the statuses for ongoing concurrent
+ * concurrent indexes have been retrieved in this transaction.
+ */
+bool yb_retrieved_concurrent_index_progress = false;
+
 /* ----------
  * Local data
  * ----------
@@ -6133,6 +6140,7 @@ pgstat_clear_snapshot(void)
 	pgStatDBHash = NULL;
 	localBackendStatusTable = NULL;
 	localNumBackends = 0;
+	yb_retrieved_concurrent_index_progress = false;
 }
 
 
diff --git a/src/postgres/src/backend/utils/adt/pgstatfuncs.c b/src/postgres/src/backend/utils/adt/pgstatfuncs.c
index afae4d0e55b8..464454824954 100644
--- a/src/postgres/src/backend/utils/adt/pgstatfuncs.c
+++ b/src/postgres/src/backend/utils/adt/pgstatfuncs.c
@@ -30,11 +30,18 @@
 #include "utils/inet.h"
 #include "utils/timestamp.h"
 
+/* YB includes */
+#include "commands/progress.h"
+
 #define UINT32_ACCESS_ONCE(var)		 ((uint32)(*((volatile uint32 *)&(var))))
 
 /* Global bgwriter statistics, from bgwriter.c */
 extern PgStat_MsgBgWriter bgwriterStats;
 
+extern bool yb_retrieved_concurrent_index_progress;
+
+uint64_t *yb_pg_stat_retrieve_concurrent_index_progress();
+
 Datum
 pg_stat_get_numscans(PG_FUNCTION_ARGS)
 {
@@ -449,6 +456,8 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 	ReturnSetInfo *rsinfo = (ReturnSetInfo *) fcinfo->resultinfo;
 	MemoryContext per_query_ctx;
 	MemoryContext oldcontext;
+	uint64_t *index_progress = NULL;
+	uint64_t *index_progress_iterator = NULL;
 
 	/* check to see if caller supports us returning a tuplestore */
 	if (rsinfo == NULL || !IsA(rsinfo, ReturnSetInfo))
@@ -470,6 +479,8 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 		cmdtype = PROGRESS_COMMAND_VACUUM;
 	else if (pg_strcasecmp(cmd, "COPY") == 0)
 		cmdtype = PROGRESS_COMMAND_COPY;
+	else if (pg_strcasecmp(cmd, "CREATE INDEX") == 0)
+		cmdtype = PROGRESS_COMMAND_CREATE_INDEX;
 	else
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
@@ -484,6 +495,27 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 	rsinfo->setDesc = tupdesc;
 	MemoryContextSwitchTo(oldcontext);
 
+	/*
+	 * Fetch stats for in-progress concurrent create indexes that aren't
+	 * captured in the local backend entry from master. We avoid reading these
+	 * stats while constructing the local backend entry in
+	 * pg_read_current_stats() in order to avoid extraneous RPCs to master
+	 * (in case we read from pg_stat_* views within a transaction but don't
+	 * read from pg_stat_progress_create_index). Since these stats are computed
+	 * on the fly and not at the time of pg_read_current_stats(), they may not
+	 * be consistent with other backend stats.
+	 * Also, the fetched values are constant within a transaction - we only
+	 * fetch from master if we haven't already done so within the current
+	 * transaction.
+	 */
+	if (IsYugaByteEnabled() && cmdtype == PROGRESS_COMMAND_CREATE_INDEX &&
+		!yb_retrieved_concurrent_index_progress)
+	{
+		index_progress = yb_pg_stat_retrieve_concurrent_index_progress();
+		index_progress_iterator = index_progress;
+		yb_retrieved_concurrent_index_progress = true;
+	}
+
 	/* 1-based index */
 	for (curr_backend = 1; curr_backend <= num_backends; curr_backend++)
 	{
@@ -511,6 +543,29 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 						beentry->st_progress_command != PROGRESS_COMMAND_COPY))
 			continue;
 
+		/*
+		 * Fill in tuples_done for concurrent create indexes on YB relations
+		 * that are in the backfilling phase.
+		 */
+		if (IsYugaByteEnabled() && cmdtype == PROGRESS_COMMAND_CREATE_INDEX &&
+			(beentry->st_progress_param[PROGRESS_CREATEIDX_COMMAND]
+			 == PROGRESS_CREATEIDX_COMMAND_CREATE_CONCURRENTLY) &&
+			(beentry->st_progress_param[PROGRESS_CREATEIDX_PHASE]
+			 == YB_PROGRESS_CREATEIDX_BACKFILLING) &&
+			IsYBRelationById(beentry->st_progress_command_target) &&
+			index_progress_iterator)
+		{
+			/*
+			 * Note: we expect the ordering of the indexes in index_progress to
+			 * to match the ordering within the backend status array -
+			 * therefore we don't need to loop through index_progress to find
+			 * the relevant entry
+			 */
+			beentry->st_progress_param[PROGRESS_CREATEIDX_TUPLES_DONE]
+				= *index_progress_iterator;
+			index_progress_iterator++;
+		}
+
 		/* Value available to all callers */
 		values[0] = Int32GetDatum(beentry->st_procpid);
 		values[1] = ObjectIdGetDatum(beentry->st_databaseid);
@@ -529,9 +584,39 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 				nulls[i + 3] = true;
 		}
 
+		/*
+		 * Set the columns of pg_stat_progress_create_index that are unused
+		 * in YB to null.
+		 */
+		if (IsYugaByteEnabled() && cmdtype == PROGRESS_COMMAND_CREATE_INDEX)
+		{
+			for (i = 0; i < PGSTAT_NUM_PROGRESS_PARAM; i++)
+			{
+				/*
+				 * In YB, we only use the command, index_relid, phase,
+				 * tuples_total, tuples_done, partitions_total, partitions_done
+				 * columns for YB indexes. For temp indexes, tuples_total and
+				 * tuples_done aren't computed so we set those to null too.
+				 */
+				if (i == PROGRESS_CREATEIDX_COMMAND ||
+					i == PROGRESS_CREATEIDX_INDEX_OID ||
+					i == PROGRESS_CREATEIDX_PHASE ||
+					i == PROGRESS_CREATEIDX_PARTITIONS_TOTAL ||
+					i == PROGRESS_CREATEIDX_PARTITIONS_DONE ||
+					(IsYBRelationById(beentry->st_progress_command_target) &&
+					 (i == PROGRESS_CREATEIDX_TUPLES_TOTAL ||
+					  i == PROGRESS_CREATEIDX_TUPLES_DONE)))
+					continue;
+				nulls[i + 3] = true;
+			}
+		}
+
 		tuplestore_putvalues(tupstore, tupdesc, values, nulls);
 	}
 
+	if (index_progress)
+		pfree(index_progress);
+
 	/* clean up and return the tuplestore */
 	tuplestore_donestoring(tupstore);
 
@@ -1989,3 +2074,55 @@ yb_pg_stat_get_backend_rss_mem_bytes(PG_FUNCTION_ARGS)
 
 	PG_RETURN_INT64(result);
 }
+
+/*
+ * In YB, this function is used to retrieve stats for in-progress concurrent
+ * CREATE INDEX from master.
+ */
+uint64_t *
+yb_pg_stat_retrieve_concurrent_index_progress()
+{
+	int			num_backends = pgstat_fetch_stat_numbackends();
+	int			curr_backend;
+	int			num_indexes = 0;
+	Oid			database_oids[num_backends];
+	Oid			index_oids[num_backends];
+	uint64_t	*progress = NULL;
+
+	for (curr_backend = 1; curr_backend <= num_backends; curr_backend++)
+	{
+		PgBackendStatus *beentry;
+		LocalPgBackendStatus *local_beentry;
+		local_beentry = pgstat_fetch_stat_local_beentry(curr_backend);
+
+		if (!local_beentry)
+			continue;
+
+		beentry = &local_beentry->backendStatus;
+
+		/*
+		 * Filter out commands besides concurrent create indexes on YB
+		 * relations that are in the backfilling phase.
+		 */
+		if (beentry->st_progress_command != PROGRESS_COMMAND_CREATE_INDEX ||
+			(beentry->st_progress_param[PROGRESS_CREATEIDX_COMMAND]
+			 != PROGRESS_CREATEIDX_COMMAND_CREATE_CONCURRENTLY) ||
+			(beentry->st_progress_param[PROGRESS_CREATEIDX_PHASE]
+			 < YB_PROGRESS_CREATEIDX_BACKFILLING) ||
+			!IsYBRelationById(beentry->st_progress_command_target))
+			continue;
+
+		database_oids[num_indexes] = beentry->st_databaseid;
+		index_oids[num_indexes++] =
+			beentry->st_progress_param[PROGRESS_CREATEIDX_INDEX_OID];
+	}
+
+	if (num_indexes > 0)
+	{
+		progress = palloc(sizeof(uint64_t) * num_indexes);
+		HandleYBStatus(YBCGetIndexBackfillProgress(index_oids, database_oids,
+												   &progress, num_indexes));
+	}
+
+	return progress;
+}
diff --git a/src/postgres/src/backend/utils/misc/guc.c b/src/postgres/src/backend/utils/misc/guc.c
index d5bb89f14703..13d4bfa4489c 100644
--- a/src/postgres/src/backend/utils/misc/guc.c
+++ b/src/postgres/src/backend/utils/misc/guc.c
@@ -4399,13 +4399,13 @@ static struct config_string ConfigureNamesString[] =
 	},
 
 	{
-		{"yb_test_block_index_state_change", PGC_SIGHUP, DEVELOPER_OPTIONS,
-			gettext_noop("Block the given index state change."),
-			gettext_noop("Valid values are \"indisready\", \"getsafetime\","
-						 " and \"indisvalid\". Any other value is ignored."),
+		{"yb_test_block_index_phase", PGC_SIGHUP, DEVELOPER_OPTIONS,
+			gettext_noop("Block the given index creation phase."),
+			gettext_noop("Valid values are \"indisready\", \"backfill\", "
+						 " and \"postbackfill\". Any other value is ignored."),
 			GUC_NOT_IN_SAMPLE
 		},
-		&yb_test_block_index_state_change,
+		&yb_test_block_index_phase,
 		"",
 		/* Could add a check function, but it's not worth the bother. */
 		NULL, NULL, NULL
diff --git a/src/postgres/src/backend/utils/misc/pg_yb_utils.c b/src/postgres/src/backend/utils/misc/pg_yb_utils.c
index 789afd606524..c1656b4baf06 100644
--- a/src/postgres/src/backend/utils/misc/pg_yb_utils.c
+++ b/src/postgres/src/backend/utils/misc/pg_yb_utils.c
@@ -1042,7 +1042,7 @@ bool yb_test_system_catalogs_creation = false;
 
 bool yb_test_fail_next_ddl = false;
 
-char *yb_test_block_index_state_change = "";
+char *yb_test_block_index_phase = "";
 
 const char*
 YBDatumToString(Datum datum, Oid typid)
diff --git a/src/postgres/src/include/catalog/pg_proc.dat b/src/postgres/src/include/catalog/pg_proc.dat
index e4f9356b0570..310cbf276d40 100644
--- a/src/postgres/src/include/catalog/pg_proc.dat
+++ b/src/postgres/src/include/catalog/pg_proc.dat
@@ -5196,9 +5196,9 @@
   proname => 'pg_stat_get_progress_info', prorows => '100', proretset => 't',
   provolatile => 's', proparallel => 'r', prorettype => 'record',
   proargtypes => 'text',
-  proallargtypes => '{text,int4,oid,oid,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8}',
-  proargmodes => '{i,o,o,o,o,o,o,o,o,o,o,o,o,o}',
-  proargnames => '{cmdtype,pid,datid,relid,param1,param2,param3,param4,param5,param6,param7,param8,param9,param10}',
+  proallargtypes => '{text,int4,oid,oid,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8,int8}',
+  proargmodes => '{i,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o}',
+  proargnames => '{cmdtype,pid,datid,relid,param1,param2,param3,param4,param5,param6,param7,param8,param9,param10,param11,param12,param13,param14,param15,param16,param17}',
   prosrc => 'pg_stat_get_progress_info' },
 { oid => '3099',
   descr => 'statistics: information about currently active replication',
diff --git a/src/postgres/src/include/catalog/pg_yb_migration.dat b/src/postgres/src/include/catalog/pg_yb_migration.dat
index 7cbf8ea68290..ddf7c11a754f 100644
--- a/src/postgres/src/include/catalog/pg_yb_migration.dat
+++ b/src/postgres/src/include/catalog/pg_yb_migration.dat
@@ -12,7 +12,7 @@
 [
 
 # For better version control conflict detection, list latest migration filename
-# here: V30__14939__yb_profiles.sql
-{ major => '30', minor => '0', name => '<baseline>', time_applied => '_null_' }
+# here: V31__10595__pg_stat_progress_create_index.sql
+{ major => '31', minor => '0', name => '<baseline>', time_applied => '_null_' }
 
 ]
diff --git a/src/postgres/src/include/commands/progress.h b/src/postgres/src/include/commands/progress.h
index 77ac5499acff..402ab86790ba 100644
--- a/src/postgres/src/include/commands/progress.h
+++ b/src/postgres/src/include/commands/progress.h
@@ -61,4 +61,29 @@ enum progress_type
 #define PROGRESS_COPY_TYPE_PIPE 3
 #define PROGRESS_COPY_TYPE_CALLBACK 4
 
+/*
+ * TODO: remove this comment after PG 13 merge
+ * The following macros and their values are imported from upstream PG.
+ * The relevant PG commit (ab0dfc961b6a821f23d9c40c723d11380ce195a6)
+ * was only partially imported to YB - so not all the commit's newly added
+ * macros are imported (only the ones used in YB are).
+ */
+
+/* Progress parameters for CREATE INDEX */
+#define PROGRESS_CREATEIDX_COMMAND				0
+#define PROGRESS_CREATEIDX_INDEX_OID			6
+#define PROGRESS_CREATEIDX_PHASE				9
+#define PROGRESS_CREATEIDX_TUPLES_TOTAL			11
+#define PROGRESS_CREATEIDX_TUPLES_DONE			12
+#define PROGRESS_CREATEIDX_PARTITIONS_TOTAL		13
+#define PROGRESS_CREATEIDX_PARTITIONS_DONE		14
+
+/* Commands of PROGRESS_CREATEIDX */
+#define PROGRESS_CREATEIDX_COMMAND_CREATE			1
+#define PROGRESS_CREATEIDX_COMMAND_CREATE_CONCURRENTLY	2
+
+/* YB phases for CREATE INDEX */
+#define YB_PROGRESS_CREATEIDX_INITIALIZING 0
+#define YB_PROGRESS_CREATEIDX_BACKFILLING 1
+
 #endif
diff --git a/src/postgres/src/include/pg_yb_utils.h b/src/postgres/src/include/pg_yb_utils.h
index 930729cd61ac..3db9f8007a37 100644
--- a/src/postgres/src/include/pg_yb_utils.h
+++ b/src/postgres/src/include/pg_yb_utils.h
@@ -519,12 +519,13 @@ extern bool yb_test_system_catalogs_creation;
 extern bool yb_test_fail_next_ddl;
 
 /*
- * Block index state changes:
- * - "indisready": indislive to indisready
- * - "getsafetime": indisready to backfill (specifically, the get safe time)
- * - "indisvalid": backfill to indisvalid
+ * Block the given index creation phase.
+ * - "indisready": index state change to indisready
+ *   (not supported for non-concurrent)
+ * - "backfill": index backfill phase
+ * - "postbackfill": post-backfill operations like validation and event triggers
  */
-extern char *yb_test_block_index_state_change;
+extern char *yb_test_block_index_phase;
 
 /*
  * See also ybc_util.h which contains additional such variable declarations for
diff --git a/src/postgres/src/include/pgstat.h b/src/postgres/src/include/pgstat.h
index bf652b075c1e..493d7ad2d6c3 100644
--- a/src/postgres/src/include/pgstat.h
+++ b/src/postgres/src/include/pgstat.h
@@ -992,10 +992,11 @@ typedef enum ProgressCommandType
 {
 	PROGRESS_COMMAND_INVALID,
 	PROGRESS_COMMAND_VACUUM,
-	PROGRESS_COMMAND_COPY
+	PROGRESS_COMMAND_COPY,
+	PROGRESS_COMMAND_CREATE_INDEX
 } ProgressCommandType;
 
-#define PGSTAT_NUM_PROGRESS_PARAM	10
+#define PGSTAT_NUM_PROGRESS_PARAM	17
 
 /* ----------
  * Shared-memory data structures
diff --git a/src/postgres/src/test/regress/expected/yb_pg_rules.out b/src/postgres/src/test/regress/expected/yb_pg_rules.out
index 3aa0cb2c41f7..88cf393af5ae 100644
--- a/src/postgres/src/test/regress/expected/yb_pg_rules.out
+++ b/src/postgres/src/test/regress/expected/yb_pg_rules.out
@@ -1835,7 +1835,35 @@ pg_stat_progress_copy| SELECT s.pid,
     s.param2 AS bytes_total,
     s.param3 AS tuples_processed,
     s.param4 AS tuples_excluded
-   FROM (pg_stat_get_progress_info('COPY'::text) s(pid, datid, relid, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10)
+   FROM (pg_stat_get_progress_info('COPY'::text) s(pid, datid, relid, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10, param11, param12, param13, param14, param15, param16, param17)
+     LEFT JOIN pg_database d ON ((s.datid = d.oid)));
+pg_stat_progress_create_index| SELECT s.pid,
+    s.datid,
+    d.datname,
+    s.relid,
+    (s.param7)::oid AS index_relid,
+        CASE s.param1
+            WHEN 1 THEN 'CREATE INDEX NONCONCURRENTLY'::text
+            WHEN 2 THEN 'CREATE INDEX CONCURRENTLY'::text
+            WHEN 3 THEN 'REINDEX NONCONCURRENTLY'::text
+            WHEN 4 THEN 'REINDEX CONCURRENTLY'::text
+            ELSE NULL::text
+        END AS command,
+        CASE s.param10
+            WHEN 0 THEN 'initializing'::text
+            WHEN 1 THEN 'backfilling'::text
+            ELSE NULL::text
+        END AS phase,
+    s.param4 AS lockers_total,
+    s.param5 AS lockers_done,
+    s.param6 AS current_locker_pid,
+    s.param16 AS blocks_total,
+    s.param17 AS blocks_done,
+    s.param12 AS tuples_total,
+    s.param13 AS tuples_done,
+    s.param14 AS partitions_total,
+    s.param15 AS partitions_done
+   FROM (pg_stat_get_progress_info('CREATE INDEX'::text) s(pid, datid, relid, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10, param11, param12, param13, param14, param15, param16, param17)
      LEFT JOIN pg_database d ON ((s.datid = d.oid)));
 pg_stat_progress_vacuum| SELECT s.pid,
     s.datid,
@@ -1857,7 +1885,7 @@ pg_stat_progress_vacuum| SELECT s.pid,
     s.param5 AS index_vacuum_count,
     s.param6 AS max_dead_tuples,
     s.param7 AS num_dead_tuples
-   FROM (pg_stat_get_progress_info('VACUUM'::text) s(pid, datid, relid, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10)
+   FROM (pg_stat_get_progress_info('VACUUM'::text) s(pid, datid, relid, param1, param2, param3, param4, param5, param6, param7, param8, param9, param10, param11, param12, param13, param14, param15, param16, param17)
      LEFT JOIN pg_database d ON ((s.datid = d.oid)));
 pg_stat_replication| SELECT s.pid,
     s.usesysid,
diff --git a/src/yb/client/client-internal.cc b/src/yb/client/client-internal.cc
index d28cb13187ee..890b05994fec 100644
--- a/src/yb/client/client-internal.cc
+++ b/src/yb/client/client-internal.cc
@@ -257,6 +257,7 @@ YB_CLIENT_SPECIALIZE_SIMPLE(ValidateReplicationInfo);
 YB_CLIENT_SPECIALIZE_SIMPLE(CheckIfPitrActive);
 YB_CLIENT_SPECIALIZE_SIMPLE_EX(Admin, CreateTransactionStatusTable);
 YB_CLIENT_SPECIALIZE_SIMPLE_EX(Admin, AddTransactionStatusTablet);
+YB_CLIENT_SPECIALIZE_SIMPLE_EX(Client, GetIndexBackfillProgress);
 YB_CLIENT_SPECIALIZE_SIMPLE_EX(Client, GetTableLocations);
 YB_CLIENT_SPECIALIZE_SIMPLE_EX(Client, GetTabletLocations);
 YB_CLIENT_SPECIALIZE_SIMPLE_EX(Client, GetTransactionStatusTablets);
diff --git a/src/yb/client/client.cc b/src/yb/client/client.cc
index 35f5f225d0ed..294edab57b9f 100644
--- a/src/yb/client/client.cc
+++ b/src/yb/client/client.cc
@@ -124,6 +124,8 @@ using yb::master::ListTablegroupsRequestPB;
 using yb::master::ListTablegroupsResponsePB;
 using yb::master::GetNamespaceInfoRequestPB;
 using yb::master::GetNamespaceInfoResponsePB;
+using yb::master::GetIndexBackfillProgressRequestPB;
+using yb::master::GetIndexBackfillProgressResponsePB;
 using yb::master::GetTableLocationsRequestPB;
 using yb::master::GetTableLocationsResponsePB;
 using yb::master::GetTabletLocationsRequestPB;
@@ -209,6 +211,7 @@ using yb::rpc::Messenger;
 using std::string;
 using std::vector;
 using std::make_pair;
+using google::protobuf::RepeatedField;
 using google::protobuf::RepeatedPtrField;
 
 using namespace yb::size_literals;  // NOLINT.
@@ -622,6 +625,22 @@ Status YBClient::BackfillIndex(const TableId& table_id, bool wait, CoarseTimePoi
   return data_->BackfillIndex(this, YBTableName(), table_id, deadline, wait);
 }
 
+Status YBClient::GetIndexBackfillProgress(
+    const std::vector<TableId>& index_ids,
+    RepeatedField<google::protobuf::uint64>* rows_processed_entries) {
+  GetIndexBackfillProgressRequestPB req;
+  GetIndexBackfillProgressResponsePB resp;
+  for (auto &index_id : index_ids) {
+    req.add_index_ids(index_id);
+  }
+  CALL_SYNC_LEADER_MASTER_RPC_EX(Client, req, resp, GetIndexBackfillProgress);
+  if (resp.has_error()) {
+    return StatusFromPB(resp.error().status());
+  }
+  *rows_processed_entries = std::move(resp.rows_processed_entries());
+  return Status::OK();
+}
+
 Status YBClient::DeleteTable(const YBTableName& table_name, bool wait) {
   auto deadline = CoarseMonoClock::Now() + default_admin_operation_timeout();
   return data_->DeleteTable(this,
diff --git a/src/yb/client/client.h b/src/yb/client/client.h
index b5f6fcf1931a..f1f91fcb5c1d 100644
--- a/src/yb/client/client.h
+++ b/src/yb/client/client.h
@@ -256,6 +256,10 @@ class YBClient {
   Status BackfillIndex(const TableId& table_id, bool wait = true,
                        CoarseTimePoint deadline = CoarseTimePoint());
 
+  Status GetIndexBackfillProgress(
+      const std::vector<TableId>& index_ids,
+      google::protobuf::RepeatedField<google::protobuf::uint64>* rows_processed_entries);
+
   // Delete the specified table.
   // Set 'wait' to true if the call must wait for the table to be fully deleted before returning.
   Status DeleteTable(const YBTableName& table_name, bool wait = true);
diff --git a/src/yb/common/common.proto b/src/yb/common/common.proto
index ace9339d3176..100a5b0421fe 100644
--- a/src/yb/common/common.proto
+++ b/src/yb/common/common.proto
@@ -226,6 +226,11 @@ message IndexInfoPB {
 
   // Where clause for partial index.
   optional WherePredicateSpecPB where_predicate_spec = 33;
+
+  // When the backfill job on this index is cleared, this field is set to the number of indexed
+  // table rows processed by the backfill job. The (default) value is zero, otherwise.
+  // For partial indexes, this includes non-matching rows of the indexed table.
+  optional uint64 num_rows_processed_by_backfill_job = 34;
 }
 
 // The possible order modes for clients.
diff --git a/src/yb/common/index.cc b/src/yb/common/index.cc
index fedbed2b4670..7bc365b0b51f 100644
--- a/src/yb/common/index.cc
+++ b/src/yb/common/index.cc
@@ -90,6 +90,7 @@ IndexInfo::IndexInfo(const IndexInfoPB& pb)
       indexed_range_column_ids_(ColumnIdsFromPB(pb.indexed_range_column_ids())),
       index_permissions_(pb.index_permissions()),
       backfill_error_message_(pb.backfill_error_message()),
+      num_rows_processed_by_backfill_job_(pb.num_rows_processed_by_backfill_job()),
       use_mangled_column_name_(pb.use_mangled_column_name()),
       where_predicate_spec_(pb.has_where_predicate_spec() ?
         std::make_shared<IndexInfoPB::WherePredicateSpecPB>(pb.where_predicate_spec()) : nullptr) {
@@ -134,6 +135,7 @@ void IndexInfo::ToPB(IndexInfoPB* pb) const {
   }
   pb->set_index_permissions(index_permissions_);
   pb->set_backfill_error_message(backfill_error_message_);
+  pb->set_num_rows_processed_by_backfill_job(num_rows_processed_by_backfill_job_);
   pb->set_use_mangled_column_name(use_mangled_column_name_);
   if (where_predicate_spec_) {
     pb->mutable_where_predicate_spec()->CopyFrom(*where_predicate_spec_);
diff --git a/src/yb/common/index.h b/src/yb/common/index.h
index bb88f139b105..29334da38678 100644
--- a/src/yb/common/index.h
+++ b/src/yb/common/index.h
@@ -107,6 +107,10 @@ class IndexInfo {
     return backfill_error_message_;
   }
 
+  uint64_t num_rows_processed_by_backfill_job() const {
+    return num_rows_processed_by_backfill_job_;
+  }
+
   std::string ToString() const;
 
   // Same as "IsExprCovered" but only search the key columns.
@@ -139,6 +143,10 @@ class IndexInfo {
   const std::vector<ColumnId> indexed_range_column_ids_; // Range column ids in the indexed table.
   const IndexPermissions index_permissions_ = INDEX_PERM_READ_WRITE_AND_DELETE;
   const std::string backfill_error_message_;
+  // When the backfill job is cleared, this is set to the number of indexed table rows processed by
+  // the backfill job. The (default) value is zero, otherwise. For partial indexes, this includes
+  // non-matching rows of the indexed table.
+  const uint64_t num_rows_processed_by_backfill_job_ = 0;
 
   // Column ids covered by the index (include indexed columns).
   std::unordered_set<ColumnId, boost::hash<ColumnIdRep>> covered_column_ids_;
diff --git a/src/yb/master/backfill_index.cc b/src/yb/master/backfill_index.cc
index 78e3d9e9b437..8c3cfae7953b 100644
--- a/src/yb/master/backfill_index.cc
+++ b/src/yb/master/backfill_index.cc
@@ -990,6 +990,11 @@ Status BackfillTable::MarkIndexesAsDesired(
           idx_pb->clear_backfill_error_message();
         }
         idx_pb->clear_is_backfill_deferred();
+        // We clear the backfill job upon completion - however, we want to persist the number
+        // of indexed table rows completed, so we record the information in the index info PB.
+        // For partial indexes, the number of rows processed includes non-matching rows of
+        // the indexed table.
+        idx_pb->set_num_rows_processed_by_backfill_job(number_rows_processed_);
       }
     }
     RETURN_NOT_OK(
diff --git a/src/yb/master/backfill_index.h b/src/yb/master/backfill_index.h
index f78146815e85..7d4728d085aa 100644
--- a/src/yb/master/backfill_index.h
+++ b/src/yb/master/backfill_index.h
@@ -153,6 +153,8 @@ class BackfillTable : public std::enable_shared_from_this<BackfillTable> {
 
   Status UpdateRowsProcessedForIndexTable(const uint64_t number_rows_processed);
 
+  const uint64_t number_rows_processed() const { return number_rows_processed_; }
+
  private:
   void LaunchBackfillOrAbort();
   Status WaitForTabletSplitting();
diff --git a/src/yb/master/catalog_manager.cc b/src/yb/master/catalog_manager.cc
index e3417e6e647c..ff7d6f472c90 100644
--- a/src/yb/master/catalog_manager.cc
+++ b/src/yb/master/catalog_manager.cc
@@ -5638,6 +5638,74 @@ Status CatalogManager::DeleteIndexInfoFromTable(
   return Status::OK();
 }
 
+Status CatalogManager::GetIndexBackfillProgress(const GetIndexBackfillProgressRequestPB* req,
+                                                GetIndexBackfillProgressResponsePB* resp,
+                                                rpc::RpcContext* rpc) {
+  VLOG(1) << "Get Index Backfill Progress request " << req->ShortDebugString();
+
+  // Note: the caller expects the ordering of the indexes in the response PB to be the
+  // same as that in the request PB.
+  for (const auto& index_id : req->index_ids()) {
+    // Retrieve the number of rows processed by the backfill job.
+    // When the backfill job is live, the num_rows_processed field in the indexed table's
+    // BackfillJobPB would give us the desired information. For backfill jobs that haven't been
+    // created or have completed/failed (and been cleared) the num_rows_processed field in the
+    // IndexInfoPB would give us the desired information.
+    // The following cases are possible:
+    // 1) The index or the indexed table is not found: the information can't be determined so
+    //    we set the num_rows_processed to 0.
+    // 2) The backfill job hasn't been created: we use IndexInfoPB's num_rows_processed (in this
+    //    case the value of this field is the default value 0).
+    // 3) The backfill job is live: we use BackfillJobPB's num_rows_processed.
+    // 4) The backfill job was successful/unsuccessful and cleared after completion:
+    //    we use IndexInfoPB's num_rows_processed.
+    // Notes:
+    // a) We are safe from concurrency issues when reading the backfill state and
+    // the index info's num_rows_processed because the updation for these two fields happens
+    // within the same LockForWrite in BackfillTable::MarkIndexesAsDesired.
+    auto index_table = GetTableInfo(index_id);
+    if (index_table == nullptr) {
+      LOG_WITH_FUNC(INFO) << "Requested Index " << index_id << " not found";
+      // No backfill job can be found for this index - set the rows processed to 0.
+      resp->add_rows_processed_entries(0);
+      continue;
+    }
+
+    // Get indexed table's TableInfo.
+    auto indexed_table = GetTableInfo(index_table->indexed_table_id());
+    if (indexed_table == nullptr) {
+      LOG_WITH_FUNC(INFO) << "Indexed table for requested index " << index_id << " not found";
+      // No backfill job can be found for this index - set the rows processed to 0.
+      resp->add_rows_processed_entries(0);
+      continue;
+    }
+
+    auto l = indexed_table->LockForRead();
+    if (l->pb.backfill_jobs_size() >= 1) {
+      // Currently we do not support multiple backfill jobs, so there can only be one outstanding
+      // backfill job. So the first (and only) backfill job at the 0th index is the only
+      // live job we need to look at.
+      DCHECK_EQ(l->pb.backfill_jobs_size(), 1) << "Expected 1 in-progress backfill job. "
+          "Found: " << l->pb.backfill_jobs_size();
+      // Check if the desired index is being backfilled by the live backfill job.
+      const auto& backfill_job = l->pb.backfill_jobs(0);
+      if (backfill_job.backfill_state().find(index_id) != backfill_job.backfill_state().end()) {
+        resp->add_rows_processed_entries(backfill_job.num_rows_processed());
+        continue;
+      }
+    }
+    // Find the desired index's IndexInfoPB from the indexed table's TableInfo.
+    for (const auto& index_info_pb : l->pb.indexes()) {
+      if (index_info_pb.table_id() == index_id) {
+        resp->add_rows_processed_entries(index_info_pb.num_rows_processed_by_backfill_job());
+        break;
+      }
+    }
+  }
+
+  return Status::OK();
+}
+
 Status CatalogManager::ScheduleDeleteTable(const scoped_refptr<TableInfo>& table) {
   return background_tasks_thread_pool_->SubmitFunc([this, table]() {
     DeleteTableRequestPB del_tbl_req;
diff --git a/src/yb/master/catalog_manager.h b/src/yb/master/catalog_manager.h
index 9441b93fdb2e..743160769237 100644
--- a/src/yb/master/catalog_manager.h
+++ b/src/yb/master/catalog_manager.h
@@ -327,6 +327,11 @@ class CatalogManager : public tserver::TabletPeerLookupIf,
                                      LaunchBackfillIndexForTableResponsePB* resp,
                                      rpc::RpcContext* rpc);
 
+  // Gets the progress of ongoing index backfills.
+  Status GetIndexBackfillProgress(const GetIndexBackfillProgressRequestPB* req,
+                                  GetIndexBackfillProgressResponsePB* resp,
+                                  rpc::RpcContext* rpc);
+
   // Schedules a table deletion to run as a background task.
   Status ScheduleDeleteTable(const scoped_refptr<TableInfo>& table);
 
diff --git a/src/yb/master/master_client.proto b/src/yb/master/master_client.proto
index 7b8c79b9a3bf..b1a778a76d2f 100644
--- a/src/yb/master/master_client.proto
+++ b/src/yb/master/master_client.proto
@@ -86,6 +86,17 @@ message TabletLocationsPB {
   optional bool is_deleted = 14;
 }
 
+message GetIndexBackfillProgressRequestPB {
+  repeated string index_ids = 1;
+}
+
+message GetIndexBackfillProgressResponsePB {
+  optional MasterErrorPB error = 1;
+  // The ordering of the indexes' results here is expected to be the same as the ordering in the
+  // corresponding request PB (GetIndexBackfillProgressRequestPB).
+  repeated uint64 rows_processed_entries = 2;
+}
+
 message GetTabletLocationsRequestPB {
   // The tablet IDs about which to fetch info.
   repeated bytes tablet_ids = 1;
@@ -219,6 +230,9 @@ service MasterClient {
   rpc ReservePgsqlOids(ReservePgsqlOidsRequestPB) returns (ReservePgsqlOidsResponsePB);
   rpc GetYsqlCatalogConfig(GetYsqlCatalogConfigRequestPB) returns (GetYsqlCatalogConfigResponsePB);
 
+  rpc GetIndexBackfillProgress(GetIndexBackfillProgressRequestPB)
+      returns (GetIndexBackfillProgressResponsePB);
+
   // Redis Config
   rpc RedisConfigSet(RedisConfigSetRequestPB) returns (RedisConfigSetResponsePB);
   rpc RedisConfigGet(RedisConfigGetRequestPB) returns (RedisConfigGetResponsePB);
diff --git a/src/yb/master/master_client_service.cc b/src/yb/master/master_client_service.cc
index 9006143ad79d..42000aaa7e61 100644
--- a/src/yb/master/master_client_service.cc
+++ b/src/yb/master/master_client_service.cc
@@ -124,6 +124,7 @@ class MasterClientServiceImpl : public MasterServiceBase, public MasterClientIf
     (RedisConfigSet)
     (RedisConfigGet)
     (ReservePgsqlOids)
+    (GetIndexBackfillProgress)
   )
 
   MASTER_SERVICE_IMPL_ON_LEADER_WITHOUT_LOCK(
diff --git a/src/yb/tserver/pg_client.proto b/src/yb/tserver/pg_client.proto
index b1dae8d11e1a..ac9c56006c4e 100644
--- a/src/yb/tserver/pg_client.proto
+++ b/src/yb/tserver/pg_client.proto
@@ -46,6 +46,8 @@ service PgClientService {
   rpc IsInitDbDone(PgIsInitDbDoneRequestPB) returns (PgIsInitDbDoneResponsePB);
   rpc ListLiveTabletServers(PgListLiveTabletServersRequestPB)
       returns (PgListLiveTabletServersResponsePB);
+  rpc GetIndexBackfillProgress(PgGetIndexBackfillProgressRequestPB)
+      returns (PgGetIndexBackfillProgressResponsePB);
   rpc OpenTable(PgOpenTableRequestPB) returns (PgOpenTableResponsePB);
   rpc Perform(PgPerformRequestPB) returns (PgPerformResponsePB) {
     option (yb.rpc.lightweight_method).sides = PROXY;
@@ -304,6 +306,17 @@ message PgLiveTabletServerPB {
   uint32 pg_port = 9;
 }
 
+message PgGetIndexBackfillProgressRequestPB {
+ repeated PgObjectIdPB index_ids = 1;
+}
+
+message PgGetIndexBackfillProgressResponsePB {
+  AppStatusPB status = 1;
+  // The ordering of the indexes' results here is expected to be the same as the ordering in the
+  // corresponding request PB (PgGetIndexBackfillProgressRequestPB).
+  repeated uint64 rows_processed_entries = 2;
+}
+
 message PgListLiveTabletServersResponsePB {
   AppStatusPB status = 1;
   repeated PgLiveTabletServerPB servers = 2;
diff --git a/src/yb/tserver/pg_client_service.cc b/src/yb/tserver/pg_client_service.cc
index 99357e46bdc7..04c1165146ea 100644
--- a/src/yb/tserver/pg_client_service.cc
+++ b/src/yb/tserver/pg_client_service.cc
@@ -305,6 +305,16 @@ class PgClientServiceImpl::Impl {
     return Status::OK();
   }
 
+  Status GetIndexBackfillProgress(
+      const PgGetIndexBackfillProgressRequestPB& req, PgGetIndexBackfillProgressResponsePB* resp,
+      rpc::RpcContext* context) {
+    std::vector<TableId> index_ids;
+    for (const auto& index_id : req.index_ids()) {
+      index_ids.emplace_back(PgObjectId::GetYbTableIdFromPB(index_id));
+    }
+    return client().GetIndexBackfillProgress(index_ids, resp->mutable_rows_processed_entries());
+  }
+
   Status ValidatePlacement(
       const PgValidatePlacementRequestPB& req, PgValidatePlacementResponsePB* resp,
       rpc::RpcContext* context) {
diff --git a/src/yb/tserver/pg_client_service.h b/src/yb/tserver/pg_client_service.h
index 36d0e9746f84..f4cee7651d15 100644
--- a/src/yb/tserver/pg_client_service.h
+++ b/src/yb/tserver/pg_client_service.h
@@ -46,6 +46,7 @@ namespace tserver {
     (FinishTransaction) \
     (GetCatalogMasterVersion) \
     (GetDatabaseInfo) \
+    (GetIndexBackfillProgress) \
     (GetTableDiskSize) \
     (Heartbeat) \
     (InsertSequenceTuple) \
diff --git a/src/yb/yql/pggate/pg_client.cc b/src/yb/yql/pggate/pg_client.cc
index bead5a74aba3..52a4611859d5 100644
--- a/src/yb/yql/pggate/pg_client.cc
+++ b/src/yb/yql/pggate/pg_client.cc
@@ -516,6 +516,25 @@ class PgClient::Impl {
     return ResponseStatus(resp);
   }
 
+  Status GetIndexBackfillProgress(const std::vector<PgObjectId>& index_ids,
+                                uint64_t** backfill_statuses) {
+    tserver::PgGetIndexBackfillProgressRequestPB req;
+    tserver::PgGetIndexBackfillProgressResponsePB resp;
+
+    for (const auto& index_id : index_ids) {
+      index_id.ToPB(req.add_index_ids());
+    }
+
+    RETURN_NOT_OK(proxy_->GetIndexBackfillProgress(req, &resp, PrepareController()));
+    RETURN_NOT_OK(ResponseStatus(resp));
+    uint64_t* backfill_status = *backfill_statuses;
+    for (const auto entry : resp.rows_processed_entries()) {
+      *backfill_status = entry;
+      backfill_status++;
+    }
+    return Status::OK();
+  }
+
   Result<int32> TabletServerCount(bool primary_only) {
     if (tablet_server_count_cache_[primary_only] > 0) {
       return tablet_server_count_cache_[primary_only];
@@ -707,6 +726,12 @@ Status PgClient::BackfillIndex(
   return impl_->BackfillIndex(req, deadline);
 }
 
+Status PgClient::GetIndexBackfillProgress(
+    const std::vector<PgObjectId>& index_ids,
+    uint64_t** backfill_statuses) {
+  return impl_->GetIndexBackfillProgress(index_ids, backfill_statuses);
+}
+
 Result<int32> PgClient::TabletServerCount(bool primary_only) {
   return impl_->TabletServerCount(primary_only);
 }
diff --git a/src/yb/yql/pggate/pg_client.h b/src/yb/yql/pggate/pg_client.h
index 6e674348c90b..e0983d30f8e9 100644
--- a/src/yb/yql/pggate/pg_client.h
+++ b/src/yb/yql/pggate/pg_client.h
@@ -38,6 +38,7 @@
 #include "yb/util/monotime.h"
 
 #include "yb/yql/pggate/pg_gate_fwd.h"
+#include "yb/yql/pggate/ybc_pg_typedefs.h"
 
 namespace yb {
 namespace pggate {
@@ -100,6 +101,9 @@ class PgClient {
 
   Status BackfillIndex(tserver::PgBackfillIndexRequestPB* req, CoarseTimePoint deadline);
 
+  Status GetIndexBackfillProgress(const std::vector<PgObjectId>& index_ids,
+                                  uint64_t** backfill_statuses);
+
   Result<int32> TabletServerCount(bool primary_only);
 
   Result<client::TabletServersInfo> ListLiveTabletServers(bool primary_only);
diff --git a/src/yb/yql/pggate/pg_session.cc b/src/yb/yql/pggate/pg_session.cc
index 39fd9fb5e61e..4fbf3ca6cc83 100644
--- a/src/yb/yql/pggate/pg_session.cc
+++ b/src/yb/yql/pggate/pg_session.cc
@@ -692,6 +692,11 @@ Result<client::TabletServersInfo> PgSession::ListTabletServers() {
   return pg_client_.ListLiveTabletServers(false);
 }
 
+Status PgSession::GetIndexBackfillProgress(std::vector<PgObjectId> index_ids,
+                                           uint64_t** backfill_statuses) {
+  return pg_client_.GetIndexBackfillProgress(index_ids, backfill_statuses);
+}
+
 bool PgSession::ShouldUseFollowerReads() const {
   return pg_txn_manager_->ShouldUseFollowerReads();
 }
diff --git a/src/yb/yql/pggate/pg_session.h b/src/yb/yql/pggate/pg_session.h
index aae34ab9f52c..b5882229f1b9 100644
--- a/src/yb/yql/pggate/pg_session.h
+++ b/src/yb/yql/pggate/pg_session.h
@@ -260,6 +260,8 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
   // -------------
   Result<client::TabletServersInfo> ListTabletServers();
 
+  Status GetIndexBackfillProgress(std::vector<PgObjectId> index_ids, uint64_t** backfill_statuses);
+
   //------------------------------------------------------------------------------------------------
   // Access functions.
   // TODO(neil) Need to double check these code later.
diff --git a/src/yb/yql/pggate/pggate.cc b/src/yb/yql/pggate/pggate.cc
index 15e578978918..5af45acaa426 100644
--- a/src/yb/yql/pggate/pggate.cc
+++ b/src/yb/yql/pggate/pggate.cc
@@ -1854,6 +1854,11 @@ Result<client::TabletServersInfo> PgApiImpl::ListTabletServers() {
   return pg_session_->ListTabletServers();
 }
 
+Status PgApiImpl::GetIndexBackfillProgress(std::vector<PgObjectId> oids,
+                                           uint64_t** backfill_statuses) {
+  return pg_session_->GetIndexBackfillProgress(oids, backfill_statuses);
+}
+
 Status PgApiImpl::ValidatePlacement(const char *placement_info) {
   return pg_session_->ValidatePlacement(placement_info);
 }
diff --git a/src/yb/yql/pggate/pggate.h b/src/yb/yql/pggate/pggate.h
index 9626959bc492..2bd656bf9801 100644
--- a/src/yb/yql/pggate/pggate.h
+++ b/src/yb/yql/pggate/pggate.h
@@ -615,6 +615,9 @@ class PgApiImpl {
 
   Result<client::TabletServersInfo> ListTabletServers();
 
+  Status GetIndexBackfillProgress(std::vector<PgObjectId> oids,
+                                  uint64_t** backfill_statuses);
+
   void StartSysTablePrefetching(uint64_t latest_known_ysql_catalog_version);
   void StopSysTablePrefetching();
   bool IsSysTablePrefetchingStarted() const;
diff --git a/src/yb/yql/pggate/ybc_pggate.cc b/src/yb/yql/pggate/ybc_pggate.cc
index 2e0999a8b3d7..dbccbc6f912b 100644
--- a/src/yb/yql/pggate/ybc_pggate.cc
+++ b/src/yb/yql/pggate/ybc_pggate.cc
@@ -1423,6 +1423,16 @@ void YBCGetAndResetReadRpcStats(YBCPgStatement handle, uint64_t* reads, uint64_t
   pgapi->GetAndResetReadRpcStats(handle, reads, read_wait, tbl_reads, tbl_read_wait);
 }
 
+YBCStatus YBCGetIndexBackfillProgress(YBCPgOid* index_oids, YBCPgOid* database_oids,
+                                      uint64_t** backfill_statuses,
+                                      int num_indexes) {
+  std::vector<PgObjectId> index_ids;
+  for (int i = 0; i < num_indexes; ++i) {
+    index_ids.emplace_back(PgObjectId(database_oids[i], index_oids[i]));
+  }
+  return ToYBCStatus(pgapi->GetIndexBackfillProgress(index_ids, backfill_statuses));
+}
+
 //------------------------------------------------------------------------------------------------
 // Thread-local variables.
 //------------------------------------------------------------------------------------------------
diff --git a/src/yb/yql/pggate/ybc_pggate.h b/src/yb/yql/pggate/ybc_pggate.h
index 71c292d0bde9..1c491caa2c1a 100644
--- a/src/yb/yql/pggate/ybc_pggate.h
+++ b/src/yb/yql/pggate/ybc_pggate.h
@@ -644,6 +644,10 @@ void YBCPgResetCatalogReadTime();
 
 YBCStatus YBCGetTabletServerHosts(YBCServerDescriptor **tablet_servers, size_t* numservers);
 
+YBCStatus YBCGetIndexBackfillProgress(YBCPgOid* index_oids, YBCPgOid* database_oids,
+                                      uint64_t** backfill_statuses,
+                                      int num_indexes);
+
 void YBCStartSysTablePrefetching(uint64_t latest_known_ysql_catalog_version);
 
 void YBCStopSysTablePrefetching();
diff --git a/src/yb/yql/pgwrapper/libpq_utils.cc b/src/yb/yql/pgwrapper/libpq_utils.cc
index 8ccb60cf8119..28449949780c 100644
--- a/src/yb/yql/pgwrapper/libpq_utils.cc
+++ b/src/yb/yql/pgwrapper/libpq_utils.cc
@@ -576,6 +576,7 @@ Result<PGResultPtr> PGConn::CopyEnd() {
 
 Result<std::string> ToString(PGresult* result, int row, int column) {
   constexpr Oid BOOLOID = 16;
+  constexpr Oid NAMEOID = 19;
   constexpr Oid INT8OID = 20;
   constexpr Oid INT2OID = 21;
   constexpr Oid INT4OID = 23;
@@ -605,6 +606,7 @@ Result<std::string> ToString(PGresult* result, int row, int column) {
       return yb::ToString(VERIFY_RESULT(GetValue<float>(result, row, column)));
     case FLOAT8OID:
       return yb::ToString(VERIFY_RESULT(GetValue<double>(result, row, column)));
+    case NAMEOID: FALLTHROUGH_INTENDED;
     case TEXTOID: FALLTHROUGH_INTENDED;
     case BPCHAROID: FALLTHROUGH_INTENDED;
     case VARCHAROID: FALLTHROUGH_INTENDED;
diff --git a/src/yb/yql/pgwrapper/pg_index_backfill-test.cc b/src/yb/yql/pgwrapper/pg_index_backfill-test.cc
index 653f28b0b5ac..a50012d73f2b 100644
--- a/src/yb/yql/pgwrapper/pg_index_backfill-test.cc
+++ b/src/yb/yql/pgwrapper/pg_index_backfill-test.cc
@@ -105,6 +105,23 @@ class PgIndexBackfillTest : public LibPqTestBase {
     return true;
   }
 
+  Status WaitForIndexProgressOutput(const std::string columns, const std::string expected_result) {
+    return WaitFor(
+      [this, &columns, &expected_result]() -> Result<bool> {
+        auto res = conn_->FetchRowAsString(
+            Format("SELECT $0 FROM pg_stat_progress_create_index", columns));
+        if (!res.ok() && res.status().IsRuntimeError() &&
+            res.status().message().ToBuffer().find("Fetched 0 rows, while 1 expected")
+            != std::string::npos) {
+          // We might have failed because the index doesn't exist yet.
+          return false;
+        }
+        return *res == expected_result;
+      },
+      30s,
+      Format("Wait for index progress columns $0 to be $1", columns, expected_result));
+  }
+
   bool HasClientTimedOut(const Status& s);
   void TestSimpleBackfill(const std::string& table_create_suffix = "");
   void TestLargeBackfill(const int num_rows);
@@ -1009,7 +1026,7 @@ class PgIndexBackfillBlockIndisready : public PgIndexBackfillTest {
  public:
   void UpdateMiniClusterOptions(ExternalMiniClusterOptions* options) override {
     PgIndexBackfillTest::UpdateMiniClusterOptions(options);
-    options->extra_tserver_flags.push_back("--ysql_yb_test_block_index_state_change=indisready");
+    options->extra_tserver_flags.push_back("--ysql_yb_test_block_index_phase=indisready");
   }
 };
 
@@ -1017,7 +1034,7 @@ class PgIndexBackfillBlockIndisreadyAndDoBackfill : public PgIndexBackfillBlockD
  public:
   void UpdateMiniClusterOptions(ExternalMiniClusterOptions* options) override {
     PgIndexBackfillBlockDoBackfill::UpdateMiniClusterOptions(options);
-    options->extra_tserver_flags.push_back("--ysql_yb_test_block_index_state_change=indisready");
+    options->extra_tserver_flags.push_back("--ysql_yb_test_block_index_phase=indisready");
   }
 };
 
@@ -1176,7 +1193,7 @@ TEST_F_EX(PgIndexBackfillTest,
           PgIndexBackfillBlockIndisready) {
   const CoarseDuration kThreadWaitTime = 60s;
   const std::array<std::tuple<IndexStateFlags, int, std::string>, 3> infos = {
-    std::make_tuple(IndexStateFlags{IndexStateFlag::kIndIsLive}, 2, "indisvalid"),
+    std::make_tuple(IndexStateFlags{IndexStateFlag::kIndIsLive}, 2, "postbackfill"),
     std::make_tuple(
         IndexStateFlags{IndexStateFlag::kIndIsLive, IndexStateFlag::kIndIsReady}, 3, "none"),
     std::make_tuple(
@@ -1217,7 +1234,7 @@ TEST_F_EX(PgIndexBackfillTest,
 
       // Unblock state change (if any).
       ASSERT_TRUE(ASSERT_RESULT(IsAtTargetIndexStateFlags(kIndexName, index_state_flags)));
-      ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_state_change", label));
+      ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", label));
       updates++;
     }
   });
@@ -1374,7 +1391,7 @@ TEST_F_EX(PgIndexBackfillTest,
 
     // Unblock CREATE INDEX waiting to set indisready.  The next blocking point is by master's
     // TEST_block_do_backfill.
-    ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_state_change", "none"));
+    ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "none"));
 
     ASSERT_OK(WaitForBackfillSafeTime(kYBTableName));
 
@@ -1786,5 +1803,220 @@ TEST_F_EX(PgIndexBackfillTest,
   TestRetainDeleteMarkers(kColoDbName);
 }
 
+// Verify in-progress CREATE INDEX command's entry in pg_stat_progress_create_index.
+TEST_F_EX(PgIndexBackfillTest,
+          YB_DISABLE_TEST_IN_TSAN(PgStatProgressCreateIndexPhase),
+          PgIndexBackfillBlockIndisreadyAndDoBackfill) {
+  constexpr int kNumRows = 10;
+
+  ASSERT_OK(conn_->ExecuteFormat("CREATE TABLE $0 (i int)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat(
+      "INSERT INTO $0 VALUES (generate_series(1, $1))", kTableName, kNumRows));
+
+  thread_holder_.AddThreadFunctor([this] {
+    auto create_conn = ASSERT_RESULT(ConnectToDB(kDatabaseName));
+    LOG(INFO) << "Begin create thread";
+    ASSERT_OK(create_conn.ExecuteFormat("CREATE INDEX $0 ON $1 (i ASC)", kIndexName, kTableName));
+  });
+
+  ASSERT_OK(WaitForIndexProgressOutput("phase", "initializing"));
+  ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "none"));
+  ASSERT_OK(WaitForIndexProgressOutput("phase", "backfilling"));
+  ASSERT_OK(cluster_->SetFlagOnMasters("TEST_block_do_backfill", "false"));
+  thread_holder_.Stop();
+}
+
+// Verify in-progress CREATE INDEX command's entries are only partially visible to users that
+// do not have the appropriate role membership.
+TEST_F_EX(PgIndexBackfillTest,
+          YB_DISABLE_TEST_IN_TSAN(PgStatProgressCreateIndexPermissions),
+          PgIndexBackfillBlockDoBackfill) {
+  constexpr int kNumRows = 10;
+  constexpr auto kUserOne = "user1";
+  constexpr auto kUserTwo = "user2";
+
+  ASSERT_OK(conn_->ExecuteFormat("CREATE USER $0", kUserOne));
+  ASSERT_OK(conn_->ExecuteFormat("CREATE USER $0", kUserTwo));
+
+  auto user_one_read_conn = ASSERT_RESULT(ConnectToDBAsUser(kDatabaseName, kUserOne));
+  auto user_two_read_conn = ASSERT_RESULT(ConnectToDBAsUser(kDatabaseName, kUserTwo));
+
+  ASSERT_OK(user_one_read_conn.ExecuteFormat("CREATE TABLE $0 (i int)", kTableName));
+  ASSERT_OK(user_one_read_conn.ExecuteFormat(
+      "INSERT INTO $0 VALUES (generate_series(1, $1))", kTableName, kNumRows));
+
+  thread_holder_.AddThreadFunctor([this] {
+    auto user_one_create_index_conn = ASSERT_RESULT(ConnectToDBAsUser(kDatabaseName, kUserOne));
+    LOG(INFO) << "Begin create thread";
+    ASSERT_OK(user_one_create_index_conn.ExecuteFormat("CREATE INDEX ON $0 (i)", kTableName));
+  });
+
+  ASSERT_OK(WaitForIndexProgressOutput("phase", "backfilling"));
+  // Assert that the new user that isn't a superuser but the owner can see the values
+  // for the selected columns.
+  constexpr auto query = "SELECT relid, command, phase, tuples_done, tuples_total"
+      " FROM pg_stat_progress_create_index";
+  auto value = ASSERT_RESULT(user_one_read_conn.FetchRowAsString(query));
+  // Assert that superuser can see the values for the selected columns.
+  ASSERT_NE(value, "NULL, NULL, NULL, NULL, NULL");
+  value = ASSERT_RESULT(conn_->FetchRowAsString(query));
+  ASSERT_NE(value, "NULL, NULL, NULL, NULL, NULL");
+  // Assert that the new user that isn't a superuser or the owner cannot see the values
+  // for the selected columns.
+  value = ASSERT_RESULT(user_two_read_conn.FetchRowAsString(query));
+  ASSERT_EQ(value, "NULL, NULL, NULL, NULL, NULL");
+  ASSERT_OK(cluster_->SetFlagOnMasters("TEST_block_do_backfill", "false"));
+  thread_holder_.Stop();
+}
+
+// Verify in-progress CREATE INDEX command's entry in pg_stat_progress_create_index is only
+// visible to the local node.
+TEST_F_EX(PgIndexBackfillTest,
+          YB_DISABLE_TEST_IN_TSAN(PgStatProgressCreateIndexMultiNode),
+          PgIndexBackfillBlockDoBackfill) {
+  constexpr int kNumRows = 10;
+
+  ASSERT_OK(conn_->ExecuteFormat("CREATE TABLE $0 (i int)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat(
+      "INSERT INTO $0 VALUES (generate_series(1, $1))", kTableName, kNumRows));
+
+  thread_holder_.AddThreadFunctor([this] {
+    auto create_conn = ASSERT_RESULT(ConnectToDB(kDatabaseName));
+    LOG(INFO) << "Begin create thread";
+    ASSERT_OK(create_conn.ExecuteFormat("CREATE INDEX ON $0 (i)", kTableName));
+  });
+
+  // Verify that entry is visible to local node (if it isn't this WaitFor will time-out).
+  ASSERT_OK(WaitForIndexProgressOutput("phase", "backfilling"));
+  // Connect to a different node.
+  pg_ts = cluster_->tablet_server(1);
+  auto different_node_conn = ASSERT_RESULT(ConnectToDB(kDatabaseName));
+  // Verify that the entry is not visible on this node.
+  auto res = ASSERT_RESULT(different_node_conn.Fetch(
+      "SELECT * FROM pg_stat_progress_create_index"));
+  ASSERT_EQ(PQntuples(res.get()), 0);
+  ASSERT_OK(cluster_->SetFlagOnMasters("TEST_block_do_backfill", "false"));
+  thread_holder_.Stop();
+}
+
+// Verify in-progress CREATE INDEX command's entry's "tuples_done" field in
+// pg_stat_progress_create_index is stable and returns the same values for multiple
+// calls within the same transaction.
+TEST_F_EX(PgIndexBackfillTest,
+          YB_DISABLE_TEST_IN_TSAN(PgStatProgressCreateIndexCheckVolatility),
+          PgIndexBackfillBlockDoBackfill) {
+  constexpr int kNumRows = 10;
+
+  ASSERT_OK(conn_->ExecuteFormat("CREATE TABLE $0 (i int)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat(
+      "INSERT INTO $0 VALUES (generate_series(1, $1))", kTableName, kNumRows));
+
+  thread_holder_.AddThreadFunctor([this] {
+    LOG(INFO) << "Begin create thread";
+    auto create_conn = ASSERT_RESULT(ConnectToDB(kDatabaseName));
+    ASSERT_OK(create_conn.ExecuteFormat(
+        "CREATE INDEX $0 ON $1 (i ASC)", kIndexName, kTableName));
+  });
+
+  ASSERT_OK(WaitForIndexProgressOutput("phase", "backfilling"));
+  ASSERT_OK(conn_->ExecuteFormat("BEGIN"));
+  // Get number of tuples done.
+  constexpr auto index_progress_query =
+      "SELECT phase, tuples_done FROM pg_stat_progress_create_index";
+  // Assert that the number of tuples done is 0 (as we have blocked the backfill).
+  auto res = ASSERT_RESULT(conn_->Fetch(index_progress_query));
+  ASSERT_EQ(ASSERT_RESULT(GetValue<PGUint64>(res.get(), 0, 1)), 0);
+  // Unblock backfill to change the actual number of tuples done.
+  ASSERT_OK(cluster_->SetFlagOnMasters("TEST_block_do_backfill", "false"));
+  thread_holder_.JoinAll();
+  // Assert that the phase is still "backfilling" and that the number of tuples done is still 0
+  // within this txn.
+  res = ASSERT_RESULT(conn_->Fetch(index_progress_query));
+  ASSERT_EQ(ASSERT_RESULT(GetString(res.get(), 0, 0)), "backfilling");
+  ASSERT_EQ(ASSERT_RESULT(GetValue<PGUint64>(res.get(), 0, 1)), 0);
+  ASSERT_OK(conn_->ExecuteFormat("COMMIT"));
+}
+
+// Verify in-progress CREATE INDEX commands' entries in pg_stat_progress_create_index
+// for concurrent gin, partial, include indexes and non-concurrent indexes.
+TEST_F(PgIndexBackfillTest,
+       YB_DISABLE_TEST_IN_TSAN(PgStatProgressCreateIndexCheckIndexTypes)) {
+  ASSERT_OK(conn_->ExecuteFormat("CREATE TABLE $0 (i int, t text, v tsvector)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat(
+      "INSERT INTO $0 VALUES (generate_series(1, 100), 'a', to_tsvector('simple', 'filler'))",
+      kTableName));
+  ASSERT_OK(conn_->ExecuteFormat("ANALYZE $0", kTableName));
+  const auto num_rows_indexed_table = ASSERT_RESULT(conn_->FetchValue<float>(
+      Format("SELECT reltuples FROM pg_class WHERE relname='$0'", kTableName)
+  ));
+
+  const std::array<std::string, 4> create_index_stmts = {
+      Format("CREATE INDEX CONCURRENTLY ON $0 USING gin (v)", kTableName),
+      Format("CREATE INDEX CONCURRENTLY ON $0 (i) WHERE i < 50", kTableName),
+      Format("CREATE INDEX CONCURRENTLY ON $0 (i) INCLUDE (t)", kTableName),
+      Format("CREATE INDEX NONCONCURRENTLY ON $0 (i)", kTableName)
+  };
+  constexpr auto cols = "datname, phase, command, tuples_total, tuples_done";
+
+  for (auto& stmt : create_index_stmts) {
+    ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "postbackfill"));
+    thread_holder_.AddThreadFunctor([this, &stmt] {
+      auto create_conn = ASSERT_RESULT(ConnectToDB(kDatabaseName));
+      LOG(INFO) << "Begin create thread";
+      ASSERT_OK(create_conn.Execute(stmt));
+    });
+    if (stmt.find("NONCONCURRENTLY") != std::string::npos) {
+      ASSERT_OK(WaitForIndexProgressOutput(cols, Format(
+          "yugabyte, backfilling, CREATE INDEX NONCONCURRENTLY, $0, $0", num_rows_indexed_table)));
+    } else {
+      ASSERT_OK(WaitForIndexProgressOutput(cols, Format(
+          "yugabyte, backfilling, CREATE INDEX CONCURRENTLY, $0, $0", num_rows_indexed_table)));
+    }
+    ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "none"));
+    thread_holder_.JoinAll();
+  }
+}
+
+// Verify in-progress CREATE INDEX commands' entries in pg_stat_progress_create_index
+// for partitioned indexes.
+TEST_F(PgIndexBackfillTest,
+       YB_DISABLE_TEST_IN_TSAN(PgStatProgressCreateIndexPartitioned)) {
+  ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "backfill"));
+  constexpr int kNumPartitions = 3;
+  ASSERT_OK(conn_->ExecuteFormat("CREATE TABLE $0 (i int) PARTITION BY RANGE(i)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat(
+    "CREATE TABLE $0_1 PARTITION OF $0 FOR VALUES FROM (1) TO (31)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat(
+      "CREATE TABLE $0_2 PARTITION OF $0 FOR VALUES FROM (31) TO (61)", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat("CREATE TABLE $0_3 PARTITION OF $0 DEFAULT", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat("INSERT INTO $0 VALUES (generate_series(1, 90))", kTableName));
+  ASSERT_OK(conn_->ExecuteFormat("ANALYZE $0", kTableName));
+
+  thread_holder_.AddThreadFunctor([this] {
+    auto create_conn = ASSERT_RESULT(ConnectToDB(kDatabaseName));
+    LOG(INFO) << "Begin create thread";
+    // Note: concurrent create index on partitioned tables is not supported - we build
+    // the index non-concurrently.
+    ASSERT_OK(create_conn.ExecuteFormat(
+        "CREATE INDEX NONCONCURRENTLY $0 ON $1 (i ASC)", kIndexName, kTableName));
+  });
+
+  constexpr auto cols =
+      "datname, command, phase, tuples_done, tuples_total, partitions_total, partitions_done";
+  // Verify entries for the partitioned indexes.
+  for (int i = 0; i < kNumPartitions; ++i) {
+    ASSERT_OK(WaitForIndexProgressOutput(cols, Format(
+        "yugabyte, CREATE INDEX NONCONCURRENTLY, initializing, 0, 30, $0, $1",
+        kNumPartitions, i)));
+    ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "postbackfill"));
+    ASSERT_OK(WaitForIndexProgressOutput(cols, Format(
+        "yugabyte, CREATE INDEX NONCONCURRENTLY, backfilling, 30, 30, $0, $1",
+        kNumPartitions, i)));
+    ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "backfill"));
+  }
+  ASSERT_OK(cluster_->SetFlagOnTServers("ysql_yb_test_block_index_phase", "none"));
+  thread_holder_.JoinAll();
+}
+
 } // namespace pgwrapper
 } // namespace yb
diff --git a/src/yb/yql/pgwrapper/pg_wrapper.cc b/src/yb/yql/pgwrapper/pg_wrapper.cc
index f651d716d555..b0d74e52566a 100644
--- a/src/yb/yql/pgwrapper/pg_wrapper.cc
+++ b/src/yb/yql/pgwrapper/pg_wrapper.cc
@@ -150,9 +150,9 @@ DEFINE_RUNTIME_PG_FLAG(string, yb_xcluster_consistency_level, "database",
     "Controls the consistency level of xCluster replicated databases. Valid values are "
     "\"database\" and \"tablet\".");
 
-DEFINE_RUNTIME_PG_FLAG(string, yb_test_block_index_state_change, "",
-    "Block the given index state change from proceeding. Valid names are indisready, getsafetime,"
-    " and indisvalid. For testing purposes.");
+DEFINE_RUNTIME_PG_FLAG(string, yb_test_block_index_phase, "",
+    "Block the given index phase from proceeding. Valid names are indisready, build,"
+    " indisvalid and finish. For testing purposes.");
 
 DEFINE_RUNTIME_AUTO_PG_FLAG(bool, yb_enable_sequence_pushdown, kLocalVolatile, false, true,
     "Allow nextval() to fetch the value range and advance the sequence value "
diff --git a/src/yb/yql/pgwrapper/ysql_migrations/V31__10595__pg_stat_progress_create_index.sql b/src/yb/yql/pgwrapper/ysql_migrations/V31__10595__pg_stat_progress_create_index.sql
new file mode 100644
index 000000000000..5079f057379b
--- /dev/null
+++ b/src/yb/yql/pgwrapper/ysql_migrations/V31__10595__pg_stat_progress_create_index.sql
@@ -0,0 +1,79 @@
+-- TODO: Remove the seperate transaction for pg_proc update after GH #13500 is fixed.
+BEGIN;
+    SET LOCAL yb_non_ddl_txn_for_sys_tables_allowed TO true;
+    UPDATE pg_catalog.pg_proc
+    SET proallargtypes = '{25,23,26,26,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20}',
+        proargmodes = '{i,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o}',
+        proargnames = '{cmdtype,pid,datid,relid,param1,param2,param3,param4,param5,param6,param7,
+        param8,param9,param10,param11,param12,param13,param14,param15,param16,param17}'
+    WHERE (proname = 'pg_stat_get_progress_info' AND
+           pronamespace = 'pg_catalog'::regnamespace);
+COMMIT;
+
+CREATE OR REPLACE VIEW pg_catalog.pg_stat_progress_create_index WITH (use_initdb_acl = true) AS
+    SELECT
+        S.pid AS pid, S.datid AS datid, D.datname AS datname,
+        S.relid AS relid,
+        CAST(S.param7 AS oid) AS index_relid,
+        CASE S.param1 WHEN 1 THEN 'CREATE INDEX NONCONCURRENTLY'
+                      WHEN 2 THEN 'CREATE INDEX CONCURRENTLY'
+                      WHEN 3 THEN 'REINDEX NONCONCURRENTLY'
+                      WHEN 4 THEN 'REINDEX CONCURRENTLY'
+                      END AS command,
+        CASE S.param10 WHEN 0 THEN 'initializing'
+                       WHEN 1 THEN 'backfilling'
+                       END AS phase,
+        S.param4 AS lockers_total,
+        S.param5 AS lockers_done,
+        S.param6 AS current_locker_pid,
+        S.param16 AS blocks_total,
+        S.param17 AS blocks_done,
+        S.param12 AS tuples_total,
+        S.param13 AS tuples_done,
+        S.param14 AS partitions_total,
+        S.param15 AS partitions_done
+    FROM pg_stat_get_progress_info('CREATE INDEX') AS S
+        LEFT JOIN pg_database D ON S.datid = D.oid;
+
+-- We also need to recreate existing views that use the pg_stat_get_progress_info function in order
+-- to update their pg_rewrite entries.
+CREATE OR REPLACE VIEW pg_catalog.pg_stat_progress_vacuum WITH (use_initdb_acl = true) AS
+    SELECT
+        S.pid AS pid, S.datid AS datid, D.datname AS datname,
+        S.relid AS relid,
+        CASE S.param1 WHEN 0 THEN 'initializing'
+                      WHEN 1 THEN 'scanning heap'
+                      WHEN 2 THEN 'vacuuming indexes'
+                      WHEN 3 THEN 'vacuuming heap'
+                      WHEN 4 THEN 'cleaning up indexes'
+                      WHEN 5 THEN 'truncating heap'
+                      WHEN 6 THEN 'performing final cleanup'
+                      END AS phase,
+        S.param2 AS heap_blks_total, S.param3 AS heap_blks_scanned,
+        S.param4 AS heap_blks_vacuumed, S.param5 AS index_vacuum_count,
+        S.param6 AS max_dead_tuples, S.param7 AS num_dead_tuples
+    FROM pg_stat_get_progress_info('VACUUM') AS S
+        LEFT JOIN pg_database D ON S.datid = D.oid;
+
+CREATE OR REPLACE VIEW pg_catalog.pg_stat_progress_copy WITH (use_initdb_acl = true) AS
+    SELECT
+        S.pid AS pid, S.datid AS datid, D.datname AS datname,
+        S.relid AS relid,
+        CASE S.param5 WHEN 1 THEN 'COPY FROM'
+                      WHEN 2 THEN 'COPY TO'
+                      END AS command,
+        CASE S.param6 WHEN 1 THEN 'FILE'
+                      WHEN 2 THEN 'PROGRAM'
+                      WHEN 3 THEN 'PIPE'
+                      WHEN 4 THEN 'CALLBACK'
+                      END AS "type",
+        CASE S.param7 WHEN 0 THEN 'IN PROGRESS'
+                      WHEN 1 THEN 'ERROR'
+                      WHEN 2 THEN 'SUCCESS'
+                      END AS yb_status,
+        S.param1 AS bytes_processed,
+        S.param2 AS bytes_total,
+        S.param3 AS tuples_processed,
+        S.param4 AS tuples_excluded
+    FROM pg_stat_get_progress_info('COPY') AS S
+        LEFT JOIN pg_database D ON S.datid = D.oid;
